#define TAPS 61
asm(" #define TAPS 61 ");

extern int h[TAPS];
int delay[TAPS];

int fir( x )
{
	static int delayptr =(int)delay;
		// input : ax0
        // output: mr1
	asm( 
		"ena m_mode;\n"
		"i0=%2;\n"			// delay ptr
		"m1=1;\n"
		"l0=TAPS;\n"		// TAPS
		"reg(b0)=%3;\n"		// base address of buffer
		"i6=%4;\n"			// end address of h
		"mx0=%5;\n"
		
    	"mr=0;\n"                       			// SUM=0
    	"dm(i0+=m1)=mx0;\n"             			// ŐṼTvXgA
    	"mx0=dm(i0+=m1),my0=pm(i6+=m5);\n"	    // v[h

    	"cntr=TAPS-1;"
    	"do fir_loop until ce;"
	"fir_loop:"
        "mr=mr+mx0*my0(ss), mx0=dm(i0+=m1),my0=pm(i6+=m5);" // Ϙa
    	"mr=mr+mx0*my0(rnd);"                               // Ō̐Ϙa    rts;        
    	"%0=mr1;"
    	"%1=i0;"								// i0 : delay ptr
    	"dis m_mode;"
	: "=e"( x ), "=e"( delayptr )
	: "e"( delayptr ), "e"( delay ), "e"( &h[TAPS-1] ), "e"( x )
	: "mr0","mr1","mr2","mx0","i0","m1","i6","m5","cntr","my0"
	);
	
	return( x );
}

int result[ 100 ];
int main(void)
{
	int i;
	
	result[0] = fir (16384);
	for ( i=1; i<100; i++ )
		result[i] = fir(0);
}
